#include "keypad.h"
#include "screenmode.h"

u32 thisKeys = 0;
u32 lastKeys = 0;
//u32 storeKeys[10]; // store the last 5 key values
u32 repeated = 0;

u32 released = 0;

int KeyPressed(u16 key) {
  if (!(thisKeys & key))
    return 1;
  return 0;
}

int KeyPressedNoBounce(u16 key, u32 r){
  if (!(thisKeys & key)) {
		// and it wasn't pressed last time..
    if ((lastKeys & key) || (!(lastKeys & key)&& r < repeated)) { 
      repeated = 0;
      return 1;
    }
    else if (!(lastKeys & key)) {
      repeated++;
		}
	}
  return 0;
}
void InitKeys(void) {
  lastKeys = 0xFFFF;
  thisKeys = 0xFFFF;
}

void UpdateKeys(void){
  lastKeys = thisKeys;
  thisKeys = KEYS;
}

void WaitKeyReleased(int key) {
  int prsd = 1;
  while (prsd) {
    // fix for highlight player's creations non-animation:
    UpdateKeys();
    wait_vsync_int();
    if (  KeyPressed(key))
      prsd = 1;
    else
      prsd = 0;
  }
}


void WaitKeyPress(int key) {
  int prsd = 0;
  while (!prsd) {
    // fix for highlight player's creations non-animation:
    UpdateKeys();
    wait_vsync_int();
    if (KeyPressed(key))
      prsd = 1;
    else
      prsd = 0;
  }
}
