#ifndef keypad_h_seen
#define keypad_h_seen
#include "gba.h"
#ifdef __cplusplus
extern "C"{
#endif

#define KEYS  REG_P1

#define GBA_VK_A        0
#define GBA_VK_B        1
#define GBA_VK_SELECT   2
#define GBA_VK_START    3
#define GBA_VK_RIGHT    4
#define GBA_VK_LEFT     5
#define GBA_VK_UP       6
#define GBA_VK_DOWN     7
#define GBA_VK_R        8
#define GBA_VK_L        9

#define KEY_A           (1<<GBA_VK_A)
#define KEY_B           (1<<GBA_VK_B)
#define KEY_SELECT      (1<<GBA_VK_SELECT)
#define KEY_START       (1<<GBA_VK_START)
#define KEY_RIGHT       (1<<GBA_VK_RIGHT)
#define KEY_LEFT        (1<<GBA_VK_LEFT)
#define KEY_UP          (1<<GBA_VK_UP)
#define KEY_DOWN        (1<<GBA_VK_DOWN)
#define KEY_R           (1<<GBA_VK_R)
#define KEY_L           (1<<GBA_VK_L)
extern u32 thisKeys;
extern u32 lastKeys;

void WaitKeyPress(int key);
void WaitKeyReleased(int key);

void InitKeys(void);
void UpdateKeys(void);
int KeyPressed(u16 key);
int KeyPressedNoBounce(u16 key, u32 r);

#ifdef __cplusplus
}
#endif
#endif
