# define which devkit to use
#export DEVDIR := D:/gbadev
export DEVDIR := /home/rich/gbadev
export DEVKITDIR := $(DEVDIR)/devkitadv
export ARM-ELF := arm-agb-elf-
ifeq ($(DEVKITARM),1)
export DEVKITDIR := $(DEVDIR)/devkitARM
export ARM-ELF := arm-elf-
endif
export GCCARM := $(DEVKITDIR)/bin


#define which java to use
#export JAVADIR := C:/jdk1.3.1/bin
export JAVADIR := D:/jdk1.3/bin
export JAVA := $(JAVADIR)/java
export JAVAC := $(JAVADIR)/javac

# define the tools
export TOOLS := $(DEVDIR)/Tools
export GFX2GBA := $(TOOLS)/gfx2gba
export GBAFIX := $(TOOLS)/headertool/ht.pl
export GBAFIX_FLAGS := -cl 
export SOX :=  sox
export RM := rm

# this prog (my own) is buggy, probably shouldn't be used!
# PCX2RAW := $(TOOLS)/pcx2raw.exe

#define which compile, objcopy etc
# this is for release 5 beta 3
#GCC := $(GCCARM)/arm-agb-elf-gcc
#AS := $(GCCARM)/arm-agb-elf-as
#OBJCOPY := $(GCCARM)/arm-agb-elf-objcopy
ifdef DEVKITARM
export OBJCOPYFLAGS := -I binary -O elf32-littlearm -B arm --rename-section .data=.rodata,readonly,contents
else
export OBJCOPYFLAGS := -I binary -O elf32-little -B arm 
endif


#export GCC := $(GCCARM)/$(ARM-ELF)gcc
#export GCC :=$(BINARM)/$(ARM-ELF)gcc
export GCC := $(GCCARM)/$(ARM-ELF)gcc
export GXX := $(GCCARM)/$(ARM-ELF)g++
export GPP := $(GXX)
export AS := $(GCCARM)/$(ARM-ELF)as
export AR := $(GCCARM)/$(ARM-ELF)ar
export OBJCOPY := $(GCCARM)/$(ARM-ELF)objcopy
export INTERFLIP := $(GCCARM)/interflip

ZIP = tar
ZIPFLAGS =  czvf
ZIPSUFFIX = tar.gz


#-g -pg -a adds basic block counting (not sure it works though... no it doesn't)
ifdef test
export DEBUG := -DDEBUG=1 -g
export LDEBUG := -L../gbalib
#-lvba
else
export DEBUG := 
export LDEBUG := 
#-lvba
endif

#compile with interworking
export CFLAGS :=  -c -mthumb-interwork $(DEBUG)
ifdef DEVKITARM
CFLAGS+= -Wall
endif
export ASFLAGS :=  -mthumb-interwork -c

