/****************************************
 screenmode.h \
 by Dovoto \
*************************************** */
#ifndef SCREENMODE_H
#define SCREENMODE_H

///// REG_DISPCNT defines

#define MODE_0 0x0
#define MODE_1 0x1
#define MODE_2 0x2
#define MODE_3 0x3
#define MODE_4 0x4
#define MODE_5 0x5

#define BACKBUFFER 0x10
#define H_BLANK_OAM 0x20 

#define OBJ_MAP_2D 0x0
#define OBJ_MAP_1D 0x40

#define FORCE_BLANK 0x80

#define BG0_ENABLE 0x100
#define BG1_ENABLE 0x200 
#define BG2_ENABLE 0x400
#define BG3_ENABLE 0x800
#define OBJ_ENABLE 0x1000 

#define WIN1_ENABLE 0x2000 
#define WIN2_ENABLE 0x4000
#define WINOBJ_ENABLE 0x8000

#define TILE_FLIP_VERT (0x800)
#define TILE_FLIP_HORZ (0x400)

///////SetMode Macro
#define SetMode(mode) REG_DISPCNT = (mode) 
// convert a colour value to 15 bit BGR value used by GBA
#define RGB16(r,g,b)  ((r)+((g)<<5)+((b)<<10)) 

// ??
#define GetRed(col)  (col&0x1f)
#define GetGreen(col) (col&0x1f)
#define GetBlue(col)  (col&0x1f)

void wait_vsync_int(void);
void screen_fade(int level);
void screen_fade_out();
void screen_fade_in();

void screen_white(int level);
void screen_white_out();
void screen_white_in();
#endif
