#ifndef SOUND_H
#define SOUND_H


typedef struct _SOUNDMAP
{
    const unsigned char *pSample; // pointer to the sample file that makes up the wav
    const unsigned char *pSampleEnd; // pointer to the end of sample file
} SoundMap;
typedef unsigned char soundtype_t;

#define DS_A_RATIO_50    0
#define DS_A_RATIO_100   (1<<0x2) 
#define DS_B_RATIO_50    0
#define DS_B_RATIO_100   (1<<0x3) 
        
#define DS_A_RIGHT       (1<<0x8)     
#define DS_A_LEFT        (1<<0x9)
#define DS_A_TIMER0      0
#define DS_A_TIMER1      (1<<0xa)
#define DS_A_FIFO        (1<<0xb)

#define DS_B_RIGHT       (1<<0xc)
#define DS_B_LEFT        (1<<0xd)        
#define DS_B_TIMER0      0
#define DS_B_TIMER1      (1<<0xe)
#define DS_B_FIFO        (1<<0xf)

#define ENABLE_DS(channel) ((channel)?ENABLE_B_FULL:ENABLE_A_FULL)
#define ENABLE_A_FULL  (DS_A_RATIO_100 | DS_A_RIGHT | DS_A_LEFT | DS_A_TIMER0 | DS_A_FIFO)
#define ENABLE_B_FULL  (DS_B_RATIO_50 | /*DS_B_RIGHT |*/ DS_B_LEFT | DS_B_TIMER0 | DS_B_FIFO)


void init_sound(void);

void Timer0UpdateSound(void);

void PlaySoundFX(unsigned char nSample);
// loops the sample the given number of times
void PlayLoopedSoundFX(unsigned char nSample, unsigned char loops);


#endif

