#ifndef TEXT16_H
#define TEXT16_H

#include"backgrounds.h"
// gfx2gba -t8 -M -F -D -c8 chaosfont.pcx
#define text16_raw _binary_chaosfont_raw_start
extern u8 text16_raw [ ];
extern u16 bgmapoffset16;
/*

The map of the characters is as follows:

' ( ) * + , - . / 0-9 : ; < = > ? @ A-Z [ \ ] ^ _ ` a-z 

The changes are:

    ASCII   |   Chaos
------------+-------------
            |
     *      |   CHAOS symbol
     +      |   LAW symbol
     /      |   %
     <      |   back arrow
     >      |   return/enter arrow
     \      |   #

e.g. "\\<>" would print "#" followed by back arrow, return arrow on screen


*/

#define MAX_LETTERS       85
#define FIRST_CHAR_INDEX  '\''
#define FILLED_CHAR_INDEX  ('z'+2)
#define TRANSP_CHAR_INDEX  ('z'+1)

void setup_text16(Bg* bg, u16 offset);
void print_text16(char* text, u16 x, u16 y , Bg* bg, u8 pal);
void set_text16_colour(u8 pal, u16 col);
unsigned short get_text16_colour(u8 pal);
void clear_bg(Bg* bg);
char * trim_whitespace(char * str);
void itoa(int n, char s[], int b);

#endif //TEXT16_H

